OGRE: Ogre::CompositorManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::CompositorManager Class Reference
Core » Effects

Class for managing Compositor settings for Ogre. More...

`#include <OgreCompositorManager.h>`

Inheritance diagram for Ogre::CompositorManager:
[legend]

## Public Types
typedef std::set< Texture * > | UniqueTextureSet
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef std::map< ResourceHandle, ResourcePtr > | ResourceHandleMap
typedef std::unordered_map< String, ResourcePtr > | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef std::unordered_map< String, ResourceMap > | ResourceWithGroupMap

## Public Member Functions
| CompositorManager ()
virtual | ~CompositorManager ()
Renderable * | _getTexturedRectangle2D ()
| Get a textured fullscreen 2D rectangle, for internal use.
void | _reconstructAllCompositorResources ()
| Internal method for forcing all active compositors to recreate their resources.
void | _relocateChain (Viewport *sourceVP, Viewport *destVP)
| Relocates a compositor chain from one viewport to another.
CompositorInstance * | addCompositor (Viewport *vp, const String &compositor, int addPosition=-1)
| Add a compositor to a viewport.
CompositorPtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new compositor.
void | freePooledTextures (bool onlyIfUnreferenced=true)
| Free pooled textures from the shared pool (compositor instances still using them will keep them in memory though).
CompositorPtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME) const
| Get a resource by name.
CompositorChain * | getCompositorChain (Viewport *vp)
| Get the compositor chain for a Viewport.
CompositorLogic * | getCompositorLogic (const String &name)
| Get a compositor logic by its name.
CustomCompositionPass * | getCustomCompositionPass (const String &name)
| Get a custom composition pass by its name.
TexturePtr | getPooledTexture (const CompositionTechnique::TextureDefinition &def, const String &localName, PixelFormat f, const String &aaHint, UniqueTextureSet &texturesAlreadyAssigned, CompositorInstance *inst)
| Utility function to get an existing pooled texture matching a given definition, or creating one if one doesn't exist.
TexturePtr | getPooledTexture (const String &name, const String &localName, uint32 w, uint32 h, PixelFormat f, uint aa, const String &aaHint, bool srgb, UniqueTextureSet &texturesAlreadyAssigned, CompositorInstance *inst, CompositionTechnique::TextureScope scope, TextureType type=TEX_TYPE_2D)
bool | hasCompositorChain (const Viewport *vp) const
| Returns whether exists compositor chain for a viewport.
bool | hasCompositorLogic (const String &name)
| Check if a compositor logic exists.
bool | hasCustomCompositionPass (const String &name)
| Check if a compositor pass exists.
void | registerCompositorLogic (const String &name, CompositorLogic *logic)
| Register a compositor logic for listening in to expecting composition techniques.
void | registerCustomCompositionPass (const String &name, CustomCompositionPass *customPass)
| Register a custom composition pass.
void | removeAll (void) override
| Overridden from ResourceManager since we have to clean up chains too.
void | removeCompositor (Viewport *vp, const String &compositor)
| Remove a compositor from a viewport.
void | removeCompositorChain (const Viewport *vp)
| Remove the compositor chain from a viewport if exists.
void | setCompositorEnabled (Viewport *vp, const String &compositor, bool value)
| Set the state of a compositor on a viewport to enabled or disabled.
void | unregisterCompositorLogic (const String &name)
| Removes a listener for compositor logic registered with registerCompositorLogic.
void | unregisterCustomCompositionPass (const String &name)
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
virtual | ~ResourceManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle) const
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder (void) const override
| Gets the loading order for scripts of this type.
size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use.
size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns (void) const override
| Gets the file patterns which should be used to find scripts for this class.
bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output.
ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse a script file.
ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
void | remove (const ResourcePtr &r)
| Remove a single resource.
void | remove (const String &name, const String &group=RGN_DEFAULT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | remove (ResourceHandle handle)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
bool | resourceExists (const String &name, const String &group=RGN_DEFAULT) const
| Returns whether the named resource exists in this manager.
bool | resourceExists (ResourceHandle handle) const
| Returns whether a resource with the given handle exists in this manager.
void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
void | unload (const String &name, const String &group=RGN_DEFAULT)
| Unloads a single resource by name.
void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< CompositorManager >
| ~Singleton (void)

## Static Public Member Functions
static CompositorManager & | getSingleton (void)
| Get the singleton instance.
static CompositorManager * | getSingletonPtr (void)
| Get the singleton instance.
Static Public Member Functions inherited from Ogre::Singleton< CompositorManager >
static CompositorManager & | getSingleton (void)
| Get the singleton instance.
static CompositorManager * | getSingletonPtr (void)
| Get the singleton instance.

## Detailed Description

Class for managing Compositor settings for Ogre.

Compositors provide the means to flexibly "composite" the final rendering result from multiple scene renders and intermediate operations like rendering fullscreen quads. This makes it possible to apply postfilter effects, HDRI postprocessing, and shadow effects to a Viewport.

  When loaded from a script, a Compositor is in an 'unloaded' state and only stores the settings required. It does not at that stage load any textures. This is because the material settings may be loaded 'en masse' from bulk material script files, but only a subset will actually be required.

  Because this is a subclass of ResourceManager, any files loaded will be searched for in any path or archive added to the resource paths/archives. See ResourceManager for details.

## Member Typedef Documentation

## ◆ UniqueTextureSet

typedef std::set<Texture*> Ogre::CompositorManager::UniqueTextureSet

## Constructor & Destructor Documentation

## ◆ CompositorManager()

Ogre::CompositorManager::CompositorManager | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~CompositorManager()

virtual Ogre::CompositorManager::~CompositorManager | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ create()

CompositorPtr Ogre::CompositorManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new compositor.

See also
  ResourceManager::createResource

## ◆ getByName()

CompositorPtr Ogre::CompositorManager::getByName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME ) const

Get a resource by name.

For example, a compositor defined in some .compositor script.

See also
  ResourceManager::getResourceByName

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getCompositorChain()

CompositorChain * Ogre::CompositorManager::getCompositorChain | ( | Viewport * | vp | ) |

Get the compositor chain for a Viewport.

If there is none yet, a new compositor chain is registered. XXX We need a _notifyViewportRemoved to find out when this viewport disappears, so we can destroy its chain as well.

## ◆ hasCompositorChain()

bool Ogre::CompositorManager::hasCompositorChain | ( | const Viewport * | vp | ) | const

Returns whether exists compositor chain for a viewport.

## ◆ removeCompositorChain()

void Ogre::CompositorManager::removeCompositorChain | ( | const Viewport * | vp | ) |

Remove the compositor chain from a viewport if exists.

## ◆ addCompositor()

CompositorInstance * Ogre::CompositorManager::addCompositor | ( | Viewport * | vp,
|  | const String & | compositor,
|  | int | addPosition = -1 )

Add a compositor to a viewport.

By default, it is added to end of the chain, after the other compositors.

Parameters

  vp | Viewport to modify
  compositor | The name of the compositor to apply
  addPosition | At which position to add, defaults to the end (-1).

Returns
  pointer to instance, or 0 if it failed.

## ◆ removeCompositor()

void Ogre::CompositorManager::removeCompositor | ( | Viewport * | vp,
|  | const String & | compositor )

Remove a compositor from a viewport.

## ◆ setCompositorEnabled()

void Ogre::CompositorManager::setCompositorEnabled | ( | Viewport * | vp,
|  | const String & | compositor,
|  | bool | value )

Set the state of a compositor on a viewport to enabled or disabled.

Disabling a compositor stops it from rendering but does not free any resources. This can be more efficient than using removeCompositor and addCompositor in cases the filter is switched on and off a lot.

## ◆ _getTexturedRectangle2D()

Renderable * Ogre::CompositorManager::_getTexturedRectangle2D | ( |  | ) |

Get a textured fullscreen 2D rectangle, for internal use.

## ◆ removeAll()

void Ogre::CompositorManager::removeAll | ( | void |  | ) |
| overridevirtual

Overridden from ResourceManager since we have to clean up chains too.

Reimplemented from Ogre::ResourceManager.

## ◆ _reconstructAllCompositorResources()

void Ogre::CompositorManager::_reconstructAllCompositorResources | ( |  | ) |

Internal method for forcing all active compositors to recreate their resources.

## ◆ getPooledTexture() [1/2]

TexturePtr Ogre::CompositorManager::getPooledTexture | ( | const CompositionTechnique::TextureDefinition & | def,
|  | const String & | localName,
|  | PixelFormat | f,
|  | const String & | aaHint,
|  | UniqueTextureSet & | texturesAlreadyAssigned,
|  | CompositorInstance * | inst )

Utility function to get an existing pooled texture matching a given definition, or creating one if one doesn't exist.

It also takes into account whether a pooled texture has already been supplied to this same requester already, in which case it won't give the same texture twice (this is important for example if you request 2 ping-pong textures, you don't want to get the same texture for both requests!

## ◆ getPooledTexture() [2/2]

TexturePtr Ogre::CompositorManager::getPooledTexture | ( | const String & | name,
|  | const String & | localName,
|  | uint32 | w,
|  | uint32 | h,
|  | PixelFormat | f,
|  | uint | aa,
|  | const String & | aaHint,
|  | bool | srgb,
|  | UniqueTextureSet & | texturesAlreadyAssigned,
|  | CompositorInstance * | inst,
|  | CompositionTechnique::TextureScope | scope,
|  | TextureType | type = TEX_TYPE_2D )

Deprecated
  do not use

References Ogre::TEX_TYPE_2D.

## ◆ freePooledTextures()

void Ogre::CompositorManager::freePooledTextures | ( | bool | onlyIfUnreferenced = true | ) |

Free pooled textures from the shared pool (compositor instances still using them will keep them in memory though).

## ◆ registerCompositorLogic()

void Ogre::CompositorManager::registerCompositorLogic | ( | const String & | name,
|  | CompositorLogic * | logic )

Register a compositor logic for listening in to expecting composition techniques.

## ◆ unregisterCompositorLogic()

void Ogre::CompositorManager::unregisterCompositorLogic | ( | const String & | name | ) |

Removes a listener for compositor logic registered with registerCompositorLogic.

## ◆ getCompositorLogic()

CompositorLogic * Ogre::CompositorManager::getCompositorLogic | ( | const String & | name | ) |

Get a compositor logic by its name.

## ◆ hasCompositorLogic()

bool Ogre::CompositorManager::hasCompositorLogic | ( | const String & | name | ) |

Check if a compositor logic exists.

## ◆ registerCustomCompositionPass()

void Ogre::CompositorManager::registerCustomCompositionPass | ( | const String & | name,
|  | CustomCompositionPass * | customPass )

Register a custom composition pass.

## ◆ unregisterCustomCompositionPass()

void Ogre::CompositorManager::unregisterCustomCompositionPass | ( | const String & | name | ) |

## ◆ getCustomCompositionPass()

CustomCompositionPass * Ogre::CompositorManager::getCustomCompositionPass | ( | const String & | name | ) |

Get a custom composition pass by its name.

## ◆ hasCustomCompositionPass()

bool Ogre::CompositorManager::hasCustomCompositionPass | ( | const String & | name | ) |

Check if a compositor pass exists.

## ◆ _relocateChain()

void Ogre::CompositorManager::_relocateChain | ( | Viewport * | sourceVP,
|  | Viewport * | destVP )

Relocates a compositor chain from one viewport to another.

Parameters

  sourceVP | The viewport to take the chain from
  destVP | The viewport to connect the chain to

## ◆ getSingleton()

CompositorManager & Ogre::CompositorManager::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

References CompositorManager().

Referenced by Python.HighPy::window_compositor(), and Python.HighPy::window_pixel_data().

## ◆ getSingletonPtr()

CompositorManager * Ogre::CompositorManager::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

References CompositorManager().

The documentation for this class was generated from the following file:

- OgreCompositorManager.h